package exnihilocreatio.blocks;

import exnihilocreatio.tiles.TileCrucibleBase;
import exnihilocreatio.tiles.TileCrucibleStone;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.IHasModel;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.IProbeInfoAccessor;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.capability.CapabilityFluidHandler;
import net.minecraftforge.fluids.capability.IFluidHandler;

import javax.annotation.Nonnull;

public abstract class BlockCrucibleBase extends Block implements IProbeInfoAccessor, IHasModel {

    public BlockCrucibleBase(String name, Material material) {
        super(material);
        func_149663_c(name);
        setRegistryName(name);

        Data.BLOCKS.add(this);
    }

    @Override
    public abstract TileEntity createTileEntity(@Nonnull World worldIn, @Nonnull IBlockState state);

    @Override
    public int func_180651_a(IBlockState state) {
        return func_176201_c(state);
    }

    @Override
    @Nonnull
    public ItemStack getPickBlock(@Nonnull IBlockState state, RayTraceResult target, @Nonnull World world, @Nonnull BlockPos pos, EntityPlayer player) {
        return new ItemStack(Item.func_150898_a(this), 1, this.func_176201_c(world.func_180495_p(pos)));
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (world.field_72995_K)
            return true;

        TileCrucibleBase te = (TileCrucibleBase) world.func_175625_s(pos);

        if (te != null) {
            IFluidHandler fluidHandler = te.getCapability(CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY, side);
            return te.onBlockActivated(world, pos, state, player, hand, side, hitX, hitY, hitZ, fluidHandler);
        } else {
            return true;
        }
    }

    @Override
    @Deprecated
    public boolean func_149730_j(IBlockState state) {
        return false;
    }

    @Override
    @Deprecated
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    @Deprecated
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Override
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world,
                             IBlockState blockState, IProbeHitData data) {
        TileCrucibleBase crucible = (TileCrucibleBase) world.func_175625_s(data.getPos());

        if (crucible == null)
            return;

        ItemStack solid = crucible.getCurrentItem() == null ? null : crucible.getCurrentItem().getItemStack();
        FluidStack liquid = crucible.getTank().getFluid();

        String solidName = solid == null ? "None" : solid.func_82833_r();
        String liquidName = liquid == null ? "None" : liquid.getLocalizedName();

        int solidAmount = Math.max(0, crucible.getSolidAmount());

        ItemStack toMelt = crucible.getItemHandler().getStackInSlot(0);

        if (!toMelt.func_190926_b()) {
            solidAmount += crucible.getCrucibleRegistry().getMeltable(toMelt).getAmount() * toMelt.func_190916_E();
        }

        probeInfo.text(String.format("Solid (%s): %d", solidName, solidAmount));
        probeInfo.text(String.format("Liquid (%s): %d", liquidName, crucible.getTank().getFluidAmount()));
        if (crucible instanceof TileCrucibleStone) {
            probeInfo.text("Rate: " + ((TileCrucibleStone) crucible).getHeatRate() + "x");
        }
    }
}
